
// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#include <sbkpep.h>
#include <sbkpepbuffer.h>

#define PYSIDE6_COMOPT_COMPRESS 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqobject.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <signalmanager.h>
#include <pysidemetafunction.h>
#include <pysideqenum.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "akonadicalendar_python.h"

// main header
#include "akonadi_etmcalendar_wrapper.h"

// Wrappers providing overrides
#include "akonadi_calendarbase_wrapper.h"
#include "akonadi_todopurger_wrapper.h"
#include "akonadi_publishdialog_wrapper.h"

// Extra includes
#include <pysidesignal.h>

// Argument includes
#include <QList>
#include <QSet>
#include <QString>
#include <QStringList>
#include <akonadi/collection.h>
#include <akonadi/entitytreemodel.h>
#include <akonadi/item.h>
#include <akonadi/monitor.h>
#include <etmcalendar.h>
#include <qabstractitemmodel.h>
#include <qbytearray.h>
#include <qdatetime.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qtimezone.h>

#include <algorithm>
#include <cctype>
#include <cstring>
#include <iterator>
#include <set>
#include <type_traits>
#include <typeinfo>

using namespace Akonadi;

extern "C" {
static PyTypeObject *Sbk_Akonadi_ETMCalendar_TypeF(void)
{
    return SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX].type;
}
} // extern "C"

// Native ---------------------------------------------------------

void ETMCalendarWrapper::resetPyMethodCache()
{
    std::fill(m_PyMethodCache.begin(), m_PyMethodCache.end(), nullptr);
}

ETMCalendarWrapper::ETMCalendarWrapper(::Akonadi::ETMCalendar * calendar, ::QObject * parent) : Akonadi::ETMCalendar(calendar, parent)
{
}

ETMCalendarWrapper::ETMCalendarWrapper(::Akonadi::Monitor * monitor, ::QObject * parent) : Akonadi::ETMCalendar(monitor, parent)
{
}

ETMCalendarWrapper::ETMCalendarWrapper(::QObject * parent) : Akonadi::ETMCalendar(parent)
{
}

ETMCalendarWrapper::ETMCalendarWrapper(const ::QStringList & mimeTypes, ::QObject * parent) : Akonadi::ETMCalendar(mimeTypes, parent)
{
}

void ETMCalendarWrapper::childEvent(::QChildEvent * event)
{
    static const char *funcName = "childEvent";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_ETMCalendar_TypeF(), gil, funcName, m_PyMethodCache[0], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::childEvent(event);
    }
    TodoPurgerWrapper::sbk_o_childEvent("ETMCalendar", funcName, gil, pyOverride, event);
}

void ETMCalendarWrapper::connectNotify(const ::QMetaMethod & signal)
{
    static const char *funcName = "connectNotify";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_ETMCalendar_TypeF(), gil, funcName, m_PyMethodCache[1], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::connectNotify(signal);
    }
    TodoPurgerWrapper::sbk_o_connectNotify("ETMCalendar", funcName, gil, pyOverride, signal);
}

void ETMCalendarWrapper::customEvent(::QEvent * event)
{
    static const char *funcName = "customEvent";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_ETMCalendar_TypeF(), gil, funcName, m_PyMethodCache[2], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::customEvent(event);
    }
    TodoPurgerWrapper::sbk_o_customEvent("ETMCalendar", funcName, gil, pyOverride, event);
}

void ETMCalendarWrapper::customPropertyUpdate()
{
    static const char *funcName = "customPropertyUpdate";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_ETMCalendar_TypeF(), gil, funcName, m_PyMethodCache[3], nameCache));
    if (pyOverride.isNull()) {
        return this->::KCalendarCore::CustomProperties::customPropertyUpdate();
    }
    PublishDialogWrapper::sbk_o_accept("ETMCalendar", funcName, gil, pyOverride);
}

void ETMCalendarWrapper::customPropertyUpdated()
{
    static const char *funcName = "customPropertyUpdated";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_ETMCalendar_TypeF(), gil, funcName, m_PyMethodCache[4], nameCache));
    if (pyOverride.isNull()) {
        return this->::KCalendarCore::Calendar::customPropertyUpdated();
    }
    PublishDialogWrapper::sbk_o_accept("ETMCalendar", funcName, gil, pyOverride);
}

void ETMCalendarWrapper::disconnectNotify(const ::QMetaMethod & signal)
{
    static const char *funcName = "disconnectNotify";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_ETMCalendar_TypeF(), gil, funcName, m_PyMethodCache[5], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::disconnectNotify(signal);
    }
    TodoPurgerWrapper::sbk_o_connectNotify("ETMCalendar", funcName, gil, pyOverride, signal);
}

void ETMCalendarWrapper::doSetTimeZone(const ::QTimeZone & timeZone)
{
    static const char *funcName = "doSetTimeZone";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_ETMCalendar_TypeF(), gil, funcName, m_PyMethodCache[6], nameCache));
    if (pyOverride.isNull()) {
        return this->::KCalendarCore::MemoryCalendar::doSetTimeZone(timeZone);
    }
    CalendarBaseWrapper::sbk_o_doSetTimeZone("ETMCalendar", funcName, gil, pyOverride, timeZone);
}

void ETMCalendarWrapper::endBatchAdding()
{
    static const char *funcName = "endBatchAdding";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_ETMCalendar_TypeF(), gil, funcName, m_PyMethodCache[7], nameCache));
    if (pyOverride.isNull()) {
        return this->::Akonadi::CalendarBase::endBatchAdding();
    }
    PublishDialogWrapper::sbk_o_accept("ETMCalendar", funcName, gil, pyOverride);
}

bool ETMCalendarWrapper::event(::QEvent * event)
{
    static const char *funcName = "event";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_ETMCalendar_TypeF(), gil, funcName, m_PyMethodCache[8], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::event(event);
    }
    return TodoPurgerWrapper::sbk_o_event("ETMCalendar", funcName, gil, pyOverride, event);
}

bool ETMCalendarWrapper::eventFilter(::QObject * watched, ::QEvent * event)
{
    static const char *funcName = "eventFilter";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_ETMCalendar_TypeF(), gil, funcName, m_PyMethodCache[9], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::eventFilter(watched, event);
    }
    return TodoPurgerWrapper::sbk_o_eventFilter("ETMCalendar", funcName, gil, pyOverride, watched, event);
}

void ETMCalendarWrapper::incidenceUpdate(const ::QString & uid, const ::QDateTime & recurrenceId)
{
    static const char *funcName = "incidenceUpdate";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_ETMCalendar_TypeF(), gil, funcName, m_PyMethodCache[10], nameCache));
    if (pyOverride.isNull()) {
        return this->::KCalendarCore::MemoryCalendar::incidenceUpdate(uid, recurrenceId);
    }
    CalendarBaseWrapper::sbk_o_incidenceUpdate("ETMCalendar", funcName, gil, pyOverride, uid, recurrenceId);
}

void ETMCalendarWrapper::incidenceUpdated(const ::QString & uid, const ::QDateTime & recurrenceId)
{
    static const char *funcName = "incidenceUpdated";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_ETMCalendar_TypeF(), gil, funcName, m_PyMethodCache[11], nameCache));
    if (pyOverride.isNull()) {
        return this->::KCalendarCore::MemoryCalendar::incidenceUpdated(uid, recurrenceId);
    }
    CalendarBaseWrapper::sbk_o_incidenceUpdate("ETMCalendar", funcName, gil, pyOverride, uid, recurrenceId);
}

void ETMCalendarWrapper::startBatchAdding()
{
    static const char *funcName = "startBatchAdding";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_ETMCalendar_TypeF(), gil, funcName, m_PyMethodCache[12], nameCache));
    if (pyOverride.isNull()) {
        return this->::Akonadi::CalendarBase::startBatchAdding();
    }
    PublishDialogWrapper::sbk_o_accept("ETMCalendar", funcName, gil, pyOverride);
}

void ETMCalendarWrapper::timerEvent(::QTimerEvent * event)
{
    static const char *funcName = "timerEvent";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_ETMCalendar_TypeF(), gil, funcName, m_PyMethodCache[13], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::timerEvent(event);
    }
    TodoPurgerWrapper::sbk_o_timerEvent("ETMCalendar", funcName, gil, pyOverride, event);
}

void ETMCalendarWrapper::virtual_hook(int id, void * data)
{
    static const char *funcName = "virtual_hook";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_ETMCalendar_TypeF(), gil, funcName, m_PyMethodCache[14], nameCache));
    if (pyOverride.isNull()) {
        return this->::KCalendarCore::MemoryCalendar::virtual_hook(id, data);
    }
    CalendarBaseWrapper::sbk_o_virtual_hook("ETMCalendar", funcName, gil, pyOverride, id, data);
}

const QMetaObject *ETMCalendarWrapper::metaObject() const
{
    if (QObject::d_ptr->metaObject != nullptr)
        return QObject::d_ptr->dynamicMetaObject();
    SbkObject *pySelf = Shiboken::BindingManager::instance().retrieveWrapper(this);
    if (pySelf == nullptr)
        return Akonadi::ETMCalendar::metaObject();
    return PySide::SignalManager::retrieveMetaObject(reinterpret_cast<PyObject *>(pySelf));
}

int ETMCalendarWrapper::qt_metacall(QMetaObject::Call call, int id, void **args)
{
    int result = Akonadi::ETMCalendar::qt_metacall(call, id, args);
    return result < 0 ? result : PySide::SignalManager::qt_metacall(this, call, id, args);
}

void *ETMCalendarWrapper::qt_metacast(const char *_clname)
{
    if (_clname == nullptr)
        return {};
    if (SbkObject *pySelf = Shiboken::BindingManager::instance().retrieveWrapper(this)) {
        auto *obSelf = reinterpret_cast<PyObject *>(pySelf);
        if (PySide::inherits(Py_TYPE(obSelf), _clname))
            return static_cast<void *>(const_cast< ETMCalendarWrapper *>(this));
    }
    return Akonadi::ETMCalendar::qt_metacast(_clname);
}

ETMCalendarWrapper::~ETMCalendarWrapper()
{
    auto *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this, Sbk_Akonadi_ETMCalendar_TypeF());
    Shiboken::Object::destroy(wrapper, this);
}

// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_Akonadi_ETMCalendar_Init(PyObject *self, PyObject *args, [[maybe_unused]] PyObject *kwds)
{
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::Akonadi::ETMCalendar >()))
        return -1;

    ETMCalendarWrapper *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    [[maybe_unused]] Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_ParseTuple(args, "|OO:ETMCalendar", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: ETMCalendar::ETMCalendar(Akonadi::ETMCalendar*,QObject*=)
    // 1: ETMCalendar::ETMCalendar(Akonadi::Monitor*,QObject*=)
    // 2: ETMCalendar::ETMCalendar(QObject*=)
    // 3: ETMCalendar::ETMCalendar(const QStringList&,QObject*=)
    if (numArgs == 0) {
        overloadId = 2; // ETMCalendar(QObject*)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 3; // ETMCalendar(QStringList,QObject*)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArgs[1])))) {
            overloadId = 3; // ETMCalendar::ETMCalendar(const QStringList&,QObject*=)
        }
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_Monitor_IDX]), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 1; // ETMCalendar(Akonadi::Monitor*,QObject*)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArgs[1])))) {
            overloadId = 1; // ETMCalendar::ETMCalendar(Akonadi::Monitor*,QObject*=)
        }
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // ETMCalendar(Akonadi::ETMCalendar*,QObject*)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArgs[1])))) {
            overloadId = 0; // ETMCalendar::ETMCalendar(Akonadi::ETMCalendar*,QObject*=)
        }
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArgs[0])))) {
        overloadId = 2; // ETMCalendar::ETMCalendar(QObject*=)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]);

    // Resolve keyword arguments
    switch (overloadId) {
        case 0: // ETMCalendar::ETMCalendar(Akonadi::ETMCalendar*,QObject*=)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                static const Shiboken::ArgumentNameIndexMapping mapping[1] = {{"parent", 1}};
                if (!Shiboken::parseConstructorKeywordArguments(kwds, mapping, 1, errInfo, pyArgs)
                    || (pyArgs[1] != nullptr && !((pythonToCpp[1] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArgs[1])))))) {
                    Py_XINCREF(errInfo.object());
                    return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]);
                }
            }
            break;
        }
        case 1: // ETMCalendar::ETMCalendar(Akonadi::Monitor*,QObject*=)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                static const Shiboken::ArgumentNameIndexMapping mapping[1] = {{"parent", 1}};
                if (!Shiboken::parseConstructorKeywordArguments(kwds, mapping, 1, errInfo, pyArgs)
                    || (pyArgs[1] != nullptr && !((pythonToCpp[1] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArgs[1])))))) {
                    Py_XINCREF(errInfo.object());
                    return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]);
                }
            }
            break;
        }
        case 2: // ETMCalendar::ETMCalendar(QObject*=)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                static const Shiboken::ArgumentNameIndexMapping mapping[1] = {{"parent", 0}};
                if (!Shiboken::parseConstructorKeywordArguments(kwds, mapping, 1, errInfo, pyArgs)
                    || (pyArgs[0] != nullptr && !((pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArgs[0])))))) {
                    Py_XINCREF(errInfo.object());
                    return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]);
                }
            }
            break;
        }
        case 3: // ETMCalendar::ETMCalendar(const QStringList&,QObject*=)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                static const Shiboken::ArgumentNameIndexMapping mapping[1] = {{"parent", 1}};
                if (!Shiboken::parseConstructorKeywordArguments(kwds, mapping, 1, errInfo, pyArgs)
                    || (pyArgs[1] != nullptr && !((pythonToCpp[1] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArgs[1])))))) {
                    Py_XINCREF(errInfo.object());
                    return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]);
                }
            }
            break;
        }
    }

    // PyMI support
    [[maybe_unused]] const bool usesPyMI = Shiboken::callInheritedInit(self, args, errInfo.isNull() ? kwds : errInfo.object(), SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // ETMCalendar(Akonadi::ETMCalendar *calendar, QObject *parent)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::Akonadi::ETMCalendar *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return -1;
            ::QObject *cppArg1 = nullptr;
            if (pythonToCpp[1])
                pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // ETMCalendar::ETMCalendar(Akonadi::ETMCalendar*,QObject*=)
                void *addr = PySide::nextQObjectMemoryAddr();
                if (addr != nullptr) {
                    cptr = new (addr) ETMCalendarWrapper(cppArg0, cppArg1);
                    PySide::setNextQObjectMemoryAddr(nullptr);
                } else {
                    cptr = new ETMCalendarWrapper(cppArg0, cppArg1);
                }

            }
            break;
        }
        case 1: // ETMCalendar(Akonadi::Monitor *monitor, QObject *parent)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::Akonadi::Monitor *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return -1;
            ::QObject *cppArg1 = nullptr;
            if (pythonToCpp[1])
                pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // ETMCalendar::ETMCalendar(Akonadi::Monitor*,QObject*=)
                void *addr = PySide::nextQObjectMemoryAddr();
                if (addr != nullptr) {
                    cptr = new (addr) ETMCalendarWrapper(cppArg0, cppArg1);
                    PySide::setNextQObjectMemoryAddr(nullptr);
                } else {
                    cptr = new ETMCalendarWrapper(cppArg0, cppArg1);
                }

            }
            break;
        }
        case 2: // ETMCalendar(QObject *parent)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QObject *cppArg0 = nullptr;
            if (pythonToCpp[0])
                pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // ETMCalendar::ETMCalendar(QObject*=)
                void *addr = PySide::nextQObjectMemoryAddr();
                if (addr != nullptr) {
                    cptr = new (addr) ETMCalendarWrapper(cppArg0);
                    PySide::setNextQObjectMemoryAddr(nullptr);
                } else {
                    cptr = new ETMCalendarWrapper(cppArg0);
                }

            }
            break;
        }
        case 3: // ETMCalendar(const QStringList &mimeTypes, QObject *parent)
        {
            ::QStringList cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return -1;
            ::QObject *cppArg1 = nullptr;
            if (pythonToCpp[1])
                pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // ETMCalendar::ETMCalendar(const QStringList&,QObject*=)
                void *addr = PySide::nextQObjectMemoryAddr();
                if (addr != nullptr) {
                    cptr = new (addr) ETMCalendarWrapper(cppArg0, cppArg1);
                    PySide::setNextQObjectMemoryAddr(nullptr);
                } else {
                    cptr = new ETMCalendarWrapper(cppArg0, cppArg1);
                }

            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< Akonadi::ETMCalendar >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::Object::setHasCppWrapper(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);

    // QObject setup
    PySide::Signal::updateSourceObject(self);
    const auto *metaObject = cptr->metaObject(); // <- init python qt properties
    if (!errInfo.isNull() && PyDict_Check(errInfo.object())) {
        if (!PySide::fillQtProperties(self, metaObject, errInfo, usesPyMI))
            return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]);
    };


    return 1;
}

static PyObject *Sbk_Akonadi_ETMCalendarFunc_collection(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    [[maybe_unused]] auto *cppSelf = reinterpret_cast< ::Akonadi::ETMCalendar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    [[maybe_unused]] Shiboken::Conversions::PythonToCppConversion pythonToCpp;

    // Overloaded function decisor
    // 0: ETMCalendar::collection(long long)const->Akonadi::Collection
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<long long>(), (pyArg)))) {
        overloadId = 0; // ETMCalendar::collection(long long)const->Akonadi::Collection
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "collection", SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]);

    // Call function/method
    {
        long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // ETMCalendar::collection(long long)const->Akonadi::Collection
            Akonadi::Collection cppResult = const_cast<const ::Akonadi::ETMCalendar *>(cppSelf)->collection(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_Collection_IDX]), &cppResult);
        }
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}

static PyObject *Sbk_Akonadi_ETMCalendarFunc_collectionFilteringEnabled(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    [[maybe_unused]] auto *cppSelf = reinterpret_cast< ::Akonadi::ETMCalendar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // ETMCalendar::collectionFilteringEnabled()const->bool
        bool cppResult = const_cast<const ::Akonadi::ETMCalendar *>(cppSelf)->collectionFilteringEnabled();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}

static PyObject *Sbk_Akonadi_ETMCalendarFunc_entityTreeModel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    [[maybe_unused]] auto *cppSelf = reinterpret_cast< ::Akonadi::ETMCalendar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // ETMCalendar::entityTreeModel()const->Akonadi::EntityTreeModel*
        Akonadi::EntityTreeModel * cppResult = const_cast<const ::Akonadi::ETMCalendar *>(cppSelf)->entityTreeModel();
        pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_EntityTreeModel_IDX]), cppResult);
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}

static PyObject *Sbk_Akonadi_ETMCalendarFunc_hasRight(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    [[maybe_unused]] auto *cppSelf = reinterpret_cast< ::Akonadi::ETMCalendar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    [[maybe_unused]] Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "hasRight", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: ETMCalendar::hasRight(const Akonadi::Item&,Akonadi::Collection::Right)const->bool
    // 1: ETMCalendar::hasRight(const QString&,Akonadi::Collection::Right)const->bool
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Enum::getConverter(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_Collection_Right_IDX]))), (pyArgs[1])))) {
        overloadId = 1; // ETMCalendar::hasRight(const QString&,Akonadi::Collection::Right)const->bool
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_Item_IDX]), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Enum::getConverter(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_Collection_Right_IDX]))), (pyArgs[1])))) {
        overloadId = 0; // ETMCalendar::hasRight(const Akonadi::Item&,Akonadi::Collection::Right)const->bool
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "hasRight", SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]);

    // Call function/method
    switch (overloadId) {
        case 0: // hasRight(const Akonadi::Item &item, Akonadi::Collection::Right right) const
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::Akonadi::Item cppArg0_local;
            ::Akonadi::Item *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);

            ::Akonadi::Collection::Right cppArg1{Akonadi::Collection::ReadOnly};
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // ETMCalendar::hasRight(const Akonadi::Item&,Akonadi::Collection::Right)const->bool
                bool cppResult = const_cast<const ::Akonadi::ETMCalendar *>(cppSelf)->hasRight(*cppArg0, cppArg1);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            }
            break;
        }
        case 1: // hasRight(const QString &uid, Akonadi::Collection::Right right) const
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::Akonadi::Collection::Right cppArg1{Akonadi::Collection::ReadOnly};
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // ETMCalendar::hasRight(const QString&,Akonadi::Collection::Right)const->bool
                bool cppResult = const_cast<const ::Akonadi::ETMCalendar *>(cppSelf)->hasRight(cppArg0, cppArg1);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            }
            break;
        }
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}

static PyObject *Sbk_Akonadi_ETMCalendarFunc_model(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    [[maybe_unused]] auto *cppSelf = reinterpret_cast< ::Akonadi::ETMCalendar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // ETMCalendar::model()const->QAbstractItemModel*
        QAbstractItemModel * cppResult = const_cast<const ::Akonadi::ETMCalendar *>(cppSelf)->model();
        pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QAbstractItemModel_IDX]), cppResult);
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}

static PyObject *Sbk_Akonadi_ETMCalendarFunc_setCollectionFilteringEnabled(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    [[maybe_unused]] auto *cppSelf = reinterpret_cast< ::Akonadi::ETMCalendar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]), reinterpret_cast<SbkObject *>(self)));
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    [[maybe_unused]] Shiboken::Conversions::PythonToCppConversion pythonToCpp;

    // Overloaded function decisor
    // 0: ETMCalendar::setCollectionFilteringEnabled(bool)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // ETMCalendar::setCollectionFilteringEnabled(bool)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setCollectionFilteringEnabled", SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]);

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // ETMCalendar::setCollectionFilteringEnabled(bool)
            cppSelf->setCollectionFilteringEnabled(cppArg0);
        }
    }

     return Sbk_ReturnFromPython_None();
}


static const char *Sbk_Akonadi_ETMCalendar_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_Akonadi_ETMCalendar_EnumFlagInfo[] = {
    "CollectionColumn:IntEnum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_Akonadi_ETMCalendar_methods[] = {
    {"collection", reinterpret_cast<PyCFunction>(Sbk_Akonadi_ETMCalendarFunc_collection), METH_O, nullptr},
    {"collectionFilteringEnabled", reinterpret_cast<PyCFunction>(Sbk_Akonadi_ETMCalendarFunc_collectionFilteringEnabled), METH_NOARGS, nullptr},
    {"entityTreeModel", reinterpret_cast<PyCFunction>(Sbk_Akonadi_ETMCalendarFunc_entityTreeModel), METH_NOARGS, nullptr},
    {"hasRight", reinterpret_cast<PyCFunction>(Sbk_Akonadi_ETMCalendarFunc_hasRight), METH_VARARGS, nullptr},
    {"model", reinterpret_cast<PyCFunction>(Sbk_Akonadi_ETMCalendarFunc_model), METH_NOARGS, nullptr},
    {"setCollectionFilteringEnabled", reinterpret_cast<PyCFunction>(Sbk_Akonadi_ETMCalendarFunc_setCollectionFilteringEnabled), METH_O, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static int Sbk_Akonadi_ETMCalendar_setattro(PyObject *self, PyObject *name, PyObject *value)
{
    PySide::Feature::Select(self);
    if (value != nullptr && PyCallable_Check(value) != 0) {
        auto plain_inst = reinterpret_cast< ::Akonadi::ETMCalendar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX]), reinterpret_cast<SbkObject *>(self)));
        auto *inst = dynamic_cast<ETMCalendarWrapper *>(plain_inst);
        if (inst != nullptr)
            inst->resetPyMethodCache();
    }
    Shiboken::AutoDecRef pp(reinterpret_cast<PyObject *>(PySide::Property::getObject(self, name)));
    if (!pp.isNull())
        return PySide::Property::setValue(reinterpret_cast<PySideProperty *>(pp.object()), self, value);
    return PyObject_GenericSetAttr(self, name, value);
}

} // extern "C"

static int Sbk_Akonadi_ETMCalendar_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PyType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_Akonadi_ETMCalendar_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PyType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
static void * Sbk_Akonadi_ETMCalendarSpecialCastFunction(void *obj, PyTypeObject *desiredType)
{
    auto me = reinterpret_cast< ::Akonadi::ETMCalendar *>(obj);
    if (desiredType == Shiboken::Module::get(SbkAkonadiCalendarTypeStructs[SBK_Akonadi_CalendarBase_IDX]))
        return static_cast< ::Akonadi::CalendarBase *>(me);
    else if (desiredType == Shiboken::Module::get(SbkKCalendarCoreTypeStructs[SBK_KCalendarCore_MemoryCalendar_IDX]))
        return static_cast< ::KCalendarCore::MemoryCalendar *>(me);
    else if (desiredType == Shiboken::Module::get(SbkKCalendarCoreTypeStructs[SBK_KCalendarCore_Calendar_IDX]))
        return static_cast< ::KCalendarCore::Calendar *>(me);
    else if (desiredType == Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]))
        return static_cast< ::QObject *>(me);
    else if (desiredType == Shiboken::Module::get(SbkKCalendarCoreTypeStructs[SBK_KCalendarCore_CustomProperties_IDX]))
        return static_cast< ::KCalendarCore::CustomProperties *>(me);
    else if (desiredType == Shiboken::Module::get(SbkKCalendarCoreTypeStructs[SBK_KCalendarCore_IncidenceBase_IncidenceObserver_IDX]))
        return static_cast< ::KCalendarCore::IncidenceBase::IncidenceObserver *>(me);
    return me;
}



// Class Definition -----------------------------------------------
extern "C" {

static PyType_Slot Sbk_Akonadi_ETMCalendar_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_setattro,    reinterpret_cast<void *>(Sbk_Akonadi_ETMCalendar_setattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_Akonadi_ETMCalendar_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_Akonadi_ETMCalendar_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_Akonadi_ETMCalendar_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_Akonadi_ETMCalendar_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_Akonadi_ETMCalendar_spec = {
    "1:AkonadiCalendar.Akonadi.ETMCalendar",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_Akonadi_ETMCalendar_slots
};

} //extern "C"

static void *Sbk_Akonadi_ETMCalendar_typeDiscovery([[maybe_unused]] void *cptr, [[maybe_unused]] PyTypeObject *instanceType)
{
    if (instanceType == Shiboken::SbkType< ::QObject >())
        return dynamic_cast< ::Akonadi::ETMCalendar *>(reinterpret_cast< ::QObject *>(cptr));
    if (instanceType == Shiboken::SbkType< ::KCalendarCore::CustomProperties >())
        return dynamic_cast< ::Akonadi::ETMCalendar *>(reinterpret_cast< ::KCalendarCore::CustomProperties *>(cptr));
    if (instanceType == Shiboken::SbkType< ::KCalendarCore::IncidenceBase::IncidenceObserver >())
        return dynamic_cast< ::Akonadi::ETMCalendar *>(reinterpret_cast< ::KCalendarCore::IncidenceBase::IncidenceObserver *>(cptr));
    return {};
}


// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_Akonadi_ETMCalendar_CollectionColumn(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::Akonadi::ETMCalendar::CollectionColumn>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::Akonadi::ETMCalendar::CollectionColumn *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_Akonadi_ETMCalendar_CollectionColumn_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_CollectionColumn_IDX])))
        return Enum_PythonToCpp_Akonadi_ETMCalendar_CollectionColumn;
    return {};
}

static PyObject *Akonadi_ETMCalendar_CollectionColumn_CppToPython_Enum(PyTypeObject *pyType, const void *cppIn)
{
    using IntType = std::underlying_type_t<::Akonadi::ETMCalendar::CollectionColumn>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::Akonadi::ETMCalendar::CollectionColumn *>(cppIn));
    return Shiboken::Enum::newItem(pyType, castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void ETMCalendar_PythonToCpp_ETMCalendar_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_Akonadi_ETMCalendar_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_ETMCalendar_PythonToCpp_ETMCalendar_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_Akonadi_ETMCalendar_TypeF()))
        return ETMCalendar_PythonToCpp_ETMCalendar_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *ETMCalendar_PTR_CppToPython_ETMCalendar(const void *cppIn)
{
    return PySide::getWrapperForQObject(reinterpret_cast<::Akonadi::ETMCalendar *>(const_cast<void *>(cppIn)), Sbk_Akonadi_ETMCalendar_TypeF());

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *Akonadi_ETMCalendar_SignatureStrings[] = {
    "3:AkonadiCalendar.Akonadi.ETMCalendar(self,calendar:AkonadiCalendar.Akonadi.ETMCalendar,parent:PySide6.QtCore.QObject=nullptr)",
    "2:AkonadiCalendar.Akonadi.ETMCalendar(self,monitor:AkonadiCore.Akonadi.Monitor,parent:PySide6.QtCore.QObject=nullptr)",
    "1:AkonadiCalendar.Akonadi.ETMCalendar(self,parent:PySide6.QtCore.QObject=nullptr)",
    "0:AkonadiCalendar.Akonadi.ETMCalendar(self,mimeTypes:QStringList,parent:PySide6.QtCore.QObject=nullptr)",
    "AkonadiCalendar.Akonadi.ETMCalendar.collection(self,arg__1:long long)->AkonadiCore.Akonadi.Collection",
    "AkonadiCalendar.Akonadi.ETMCalendar.collectionFilteringEnabled(self)->bool",
    "AkonadiCalendar.Akonadi.ETMCalendar.entityTreeModel(self)->AkonadiCore.Akonadi.EntityTreeModel",
    "1:AkonadiCalendar.Akonadi.ETMCalendar.hasRight(self,item:AkonadiCore.Akonadi.Item,right:AkonadiCore.Akonadi.Collection.Right)->bool",
    "0:AkonadiCalendar.Akonadi.ETMCalendar.hasRight(self,uid:QString,right:AkonadiCore.Akonadi.Collection.Right)->bool",
    "AkonadiCalendar.Akonadi.ETMCalendar.model(self)->PySide6.QtCore.QAbstractItemModel",
    "AkonadiCalendar.Akonadi.ETMCalendar.setCollectionFilteringEnabled(self,enable:bool)",
    nullptr}; // Sentinel
#else
static constexpr size_t Akonadi_ETMCalendar_SignatureByteSize = 287;
static constexpr uint8_t Akonadi_ETMCalendar_SignatureBytes[287] = {
    0x78, 0xda, 0x9d, 0x92, 0x4d, 0x6b, 0xc3, 0x30, 0x0c, 0x86, 0xef, 0xfd, 0x15, 0x3b, 0x2e, 0x90,
    0x99, 0x76, 0x83, 0x1d, 0x0c, 0x1b, 0x94, 0x90, 0xc1, 0x60, 0x61, 0xcb, 0x9a, 0x7b, 0x71, 0x62,
    0x35, 0xd5, 0xe6, 0xd8, 0xc1, 0x56, 0x0f, 0xf9, 0xf7, 0x8b, 0x93, 0x66, 0x5f, 0x84, 0xe2, 0xf6,
    0x62, 0x90, 0x2d, 0xe9, 0xd1, 0xfb, 0xca, 0x77, 0x7c, 0xfd, 0x69, 0xb4, 0x90, 0x98, 0x08, 0x05,
    0x5a, 0x0a, 0xcb, 0x8e, 0x31, 0x4b, 0x8b, 0x6c, 0xba, 0xbb, 0x76, 0xa0, 0x76, 0x71, 0x75, 0x8c,
    0x42, 0x2a, 0xe2, 0x56, 0x58, 0xd0, 0xc4, 0xdf, 0xba, 0x0d, 0x4a, 0xb8, 0x67, 0x39, 0x25, 0xc6,
    0x02, 0xcb, 0x5f, 0xcb, 0x0f, 0xa8, 0xe8, 0x41, 0x1f, 0x94, 0x6a, 0xc9, 0x46, 0x8b, 0xdb, 0x70,
    0x7c, 0x63, 0x34, 0x92, 0xf9, 0xa1, 0xfb, 0x7e, 0x53, 0x72, 0x36, 0xbe, 0x85, 0x52, 0x57, 0xe1,
    0xd4, 0xc0, 0x8e, 0xcb, 0x33, 0x74, 0x60, 0x03, 0x45, 0xd7, 0x82, 0xe3, 0xf9, 0x86, 0x2c, 0xea,
    0xfa, 0x05, 0x1d, 0x85, 0x72, 0x02, 0x28, 0xac, 0x32, 0x4a, 0xf5, 0x45, 0x68, 0xf4, 0x08, 0x14,
    0xb6, 0xde, 0x6e, 0x57, 0x5c, 0x19, 0x5d, 0x5f, 0xf9, 0x23, 0xba, 0x79, 0x9c, 0xf3, 0x30, 0xf9,
    0x2e, 0x3b, 0x93, 0xf2, 0x84, 0x8a, 0xc0, 0x0b, 0x49, 0xb5, 0x28, 0x15, 0xc8, 0x81, 0xda, 0x43,
    0x4a, 0x63, 0x54, 0x50, 0xab, 0x5e, 0x38, 0x52, 0x57, 0x58, 0x80, 0xcc, 0x48, 0x50, 0x53, 0xfd,
    0xdc, 0x90, 0xe9, 0xdf, 0xd4, 0xb0, 0x4d, 0xb2, 0xbd, 0x70, 0xef, 0x58, 0xef, 0x69, 0xf4, 0x03,
    0x09, 0x9a, 0xd9, 0x5f, 0xf4, 0xdc, 0x3f, 0xc4, 0xd6, 0x27, 0xf2, 0xd3, 0x06, 0xb1, 0xa1, 0xdb,
    0x24, 0x71, 0x79, 0xc1, 0x0c, 0x07, 0x94, 0xd3, 0xfa, 0x2f, 0x20, 0x86, 0xf0, 0x9a, 0xdf, 0x56,
    0xfe, 0xff, 0x56, 0xeb, 0xd2, 0x91, 0x15, 0x15, 0x79, 0xc5, 0xa3, 0x91, 0x21, 0x2d, 0x1d, 0x50,
    0x72, 0x7a, 0xeb, 0x31, 0x0c, 0x01, 0xf7, 0x53, 0x46, 0x8b, 0x2f, 0x84, 0x77, 0x96, 0x43
};
#endif

PyTypeObject *init_Akonadi_ETMCalendar(PyObject *enclosingClass)
{
    auto &typeStruct = SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_IDX];
    if (typeStruct.type != nullptr)
        return typeStruct.type;

    auto *base1 = reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkAkonadiCalendarTypeStructs[SBK_Akonadi_CalendarBase_IDX]));
    Shiboken::AutoDecRef Sbk_Akonadi_ETMCalendar_Type_bases(PyTuple_Pack(1, base1));

    PyTypeObject *pyType = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "ETMCalendar",
        "Akonadi::ETMCalendar*",
        &Sbk_Akonadi_ETMCalendar_spec,
        &Shiboken::callCppDestructor< Akonadi::ETMCalendar >,
        Sbk_Akonadi_ETMCalendar_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass);
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, Akonadi_ETMCalendar_SignatureStrings);
#else
    InitSignatureBytes(pyType, Akonadi_ETMCalendar_SignatureBytes, Akonadi_ETMCalendar_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_Akonadi_ETMCalendar_PropertyStrings);
    typeStruct.type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        ETMCalendar_PythonToCpp_ETMCalendar_PTR,
        is_ETMCalendar_PythonToCpp_ETMCalendar_PTR_Convertible,
        ETMCalendar_PTR_CppToPython_ETMCalendar);

    Shiboken::Conversions::registerConverterName(converter, "Akonadi::ETMCalendar");
    Shiboken::Conversions::registerConverterName(converter, "Akonadi::ETMCalendar*");
    Shiboken::Conversions::registerConverterName(converter, "Akonadi::ETMCalendar&");
    Shiboken::Conversions::registerConverterAlias(converter, "ETMCalendar");
    Shiboken::Conversions::registerConverterAlias(converter, "ETMCalendar*");
    Shiboken::Conversions::registerConverterAlias(converter, "ETMCalendar&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::Akonadi::ETMCalendar).name());
    Shiboken::Conversions::registerConverterName(converter, typeid(ETMCalendarWrapper).name());

    MultipleInheritanceInitFunction func = Shiboken::ObjectType::getMultipleInheritanceFunction(Shiboken::Module::get(SbkKCalendarCoreTypeStructs[SBK_KCalendarCore_Calendar_IDX]));
    Shiboken::ObjectType::setMultipleInheritanceFunction(Sbk_Akonadi_ETMCalendar_TypeF(), func);
    Shiboken::ObjectType::setCastFunction(Sbk_Akonadi_ETMCalendar_TypeF(), &Sbk_Akonadi_ETMCalendarSpecialCastFunction);
    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(pyType, &Sbk_Akonadi_ETMCalendar_typeDiscovery);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_Akonadi_ETMCalendar_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    [[maybe_unused]] PyTypeObject *EType{};

    // Initialization of enum 'CollectionColumn'.
    const char *CollectionColumn_Initializer[] = {
        "CollectionTitle",
        "CollectionColumnCount",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t CollectionColumn_InitializerValues[] = {
        uint8_t(Akonadi::ETMCalendar::CollectionColumn::CollectionTitle),      //  0x00  0
        uint8_t(Akonadi::ETMCalendar::CollectionColumn::CollectionColumnCount) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(pyType,
        "1:AkonadiCalendar.Akonadi.ETMCalendar.CollectionColumn",
        CollectionColumn_Initializer, CollectionColumn_InitializerValues);
    SbkAkonadiCalendarTypeStructs[SBK_Akonadi_ETMCalendar_CollectionColumn_IDX].type = EType;
    // Register converter for enum 'Akonadi::ETMCalendar::CollectionColumn'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            Akonadi_ETMCalendar_CollectionColumn_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_Akonadi_ETMCalendar_CollectionColumn,
            is_Enum_PythonToCpp_Akonadi_ETMCalendar_CollectionColumn_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "Akonadi::ETMCalendar::CollectionColumn");
        Shiboken::Conversions::registerConverterAlias(converter, "ETMCalendar::CollectionColumn");
        Shiboken::Conversions::registerConverterAlias(converter, "CollectionColumn");
        Shiboken::Enum::setTypeConverter(EType, converter, nullptr);
    }
    // End of 'CollectionColumn' enum.

    PySide::Signal::registerSignals(pyType, &::Akonadi::ETMCalendar::staticMetaObject);
    qRegisterMetaType< ::Akonadi::ETMCalendar::CollectionColumn >("ETMCalendar::CollectionColumn");
    qRegisterMetaType< ::Akonadi::ETMCalendar::CollectionColumn >("Akonadi::ETMCalendar::CollectionColumn");
    Shiboken::ObjectType::setSubTypeInitHook(pyType, &PySide::initQObjectSubType);
    PySide::initDynamicMetaObject(pyType, &::Akonadi::ETMCalendar::staticMetaObject, sizeof(ETMCalendarWrapper));

    return pyType;
}
